# HOT Comp Rust Starter Code

## Installing Rust
Follow instructions from [here](https://www.rust-lang.org/tools/install)

## Building the Compiler 
Simply run `cargo build`

## Running the Compiler
`cargo run <filename.sax>`

## Directory Layout
- `src/main.rs`: Main entry point
- `src/parse.rs`: Entry point for the parsing module. Contains relevant `parse_from_file` function.
- `src/parse/ast.rs`: Type defintions for the AST structure
- `src/parse/lex.rs`: The lexer.
- `src/parse/sax.lalrpop`: The lalrpop parser generator. You can read more [here](https://lalrpop.github.io/lalrpop/).
    Building the compiler will make a `sax.rs` file in `src/parse/sax.rs` which contains the autogenerated parser.
